package esi.ew.report.RP001;

public class RP001Result {
	//1
	private Integer subjectID;
	private String subjectCodeName;
	private String totalExamItemNo;
	private String orderOfObjectiveInSection;
	private Integer unitID;
	private String unit;
	private String unitName;
	private Integer sectionID;
	private String section;
	private Integer objectiveID;
	private String objective;
	private Integer behaviorID;
	private String behaviorDefinition;
	private String examItemNo;
	private String totalExamItemNoInSection;
	private String totalExamItemNoInUnit;
	private String lastOrderOfObjectiveInSection;
	private String totalOfBehavior;
	private String showTotalExamItemNoInSection = "0";
	//2
	public RP001Result(){
		this.subjectID = -1;
		this.subjectCodeName = "";
		this.totalExamItemNo = "";
		this.orderOfObjectiveInSection = "";
		this.unitID = -1;
		this.unit = "";
		this.unitName = "";
		this.sectionID = -1;
		this.section = "";
		this.objectiveID = -1;
		this.behaviorID = -1;
		this.behaviorDefinition = "-";
		this.examItemNo = "";
		this.totalExamItemNoInSection = "";
		this.totalExamItemNoInUnit = "";	
		this.lastOrderOfObjectiveInSection = "";
		this.totalOfBehavior = "";
		this.showTotalExamItemNoInSection = "0";
	}
	
	//3
	
	public String getSubjectCodeName() {
		return subjectCodeName;
	}

	public Integer getSubjectID() {
		return subjectID;
	}

	public void setSubjectID(Integer subjectID) {
		this.subjectID = subjectID;
	}

	public void setSubjectCodeName(String subjectCodeName) {
		this.subjectCodeName = subjectCodeName;
	}

	public String getTotalExamItemNo() {
		return totalExamItemNo;
	}

	public void setTotalExamItemNo(String totalExamItemNo) {
		this.totalExamItemNo = totalExamItemNo;
	}

	public String getUnit() {
		return unit;
	}

	public void setUnit(String unit) {
		this.unit = unit;
	}

	public String getSection() {
		return section;
	}

	public void setSection(String section) {
		this.section = section;
	}

	public String getObjective() {
		return objective;
	}

	public void setObjective(String objective) {
		this.objective = objective;
	}

	public String getBehaviorDefinition() {
		return behaviorDefinition;
	}

	public void setBehaviorDefinition(String behaviorDefinition) {
		this.behaviorDefinition = behaviorDefinition;
	}

	public String getExamItemNo() {
		return examItemNo;
	}

	public void setExamItemNo(String examItemNo) {
		this.examItemNo = examItemNo;
	}

	public String getTotalExamItemNoInSection() {
		return totalExamItemNoInSection;
	}

	public void setTotalExamItemNoInSection(String totalExamItemNoInSection) {
		this.totalExamItemNoInSection = totalExamItemNoInSection;
	}

	public String getTotalExamItemNoInUnit() {
		return totalExamItemNoInUnit;
	}

	public void setTotalExamItemNoInUnit(String totalExamItemNoInUnit) {
		this.totalExamItemNoInUnit = totalExamItemNoInUnit;
	}

	public Integer getUnitID() {
		return unitID;
	}

	public void setUnitID(Integer unitID) {
		this.unitID = unitID;
	}

	public Integer getSectionID() {
		return sectionID;
	}

	public void setSectionID(Integer sectionID) {
		this.sectionID = sectionID;
	}

	public Integer getObjectiveID() {
		return objectiveID;
	}

	public void setObjectiveID(Integer objectiveID) {
		this.objectiveID = objectiveID;
	}

	public String getOrderOfObjectiveInSection() {
		return orderOfObjectiveInSection;
	}

	public void setOrderOfObjectiveInSection(String orderOfObjectiveInSection) {
		this.orderOfObjectiveInSection = orderOfObjectiveInSection;
	}

	public String getLastOrderOfObjectiveInSection() {
		return lastOrderOfObjectiveInSection;
	}

	public void setLastOrderOfObjectiveInSection(
			String lastOrderOfObjectiveInSection) {
		this.lastOrderOfObjectiveInSection = lastOrderOfObjectiveInSection;
	}

	public Integer getBehaviorID() {
		return behaviorID;
	}

	public void setBehaviorID(Integer behaviorID) {
		this.behaviorID = behaviorID;
	}

	public String getUnitName() {
		return unitName;
	}

	public void setUnitName(String unitName) {
		this.unitName = unitName;
	}

	/**
	 * @return the totalOfBehavior
	 */
	public String getTotalOfBehavior() {
		return totalOfBehavior;
	}

	/**
	 * @param totalOfBehavior the totalOfBehavior to set
	 */
	public void setTotalOfBehavior(String totalOfBehavior) {
		this.totalOfBehavior = totalOfBehavior;
	}

	public String getShowTotalExamItemNoInSection() {
		return showTotalExamItemNoInSection;
	}

	public void setShowTotalExamItemNoInSection(String showTotalExamItemNoInSection) {
		this.showTotalExamItemNoInSection = showTotalExamItemNoInSection;
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("RP001Result [subjectID=");
		builder.append(subjectID);
		builder.append(", subjectCodeName=");
		builder.append(subjectCodeName);
		builder.append(", totalExamItemNo=");
		builder.append(totalExamItemNo);
		builder.append(", orderOfObjectiveInSection=");
		builder.append(orderOfObjectiveInSection);
		builder.append(", unitID=");
		builder.append(unitID);
		builder.append(", unit=");
		builder.append(unit);
		builder.append(", unitName=");
		builder.append(unitName);
		builder.append(", sectionID=");
		builder.append(sectionID);
		builder.append(", section=");
		builder.append(section);
		builder.append(", objectiveID=");
		builder.append(objectiveID);
		builder.append(", objective=");
		builder.append(objective);
		builder.append(", behaviorID=");
		builder.append(behaviorID);
		builder.append(", behaviorDefinition=");
		builder.append(behaviorDefinition);
		builder.append(", examItemNo=");
		builder.append(examItemNo);
		builder.append(", totalExamItemNoInSection=");
		builder.append(totalExamItemNoInSection);
		builder.append(", totalExamItemNoInUnit=");
		builder.append(totalExamItemNoInUnit);
		builder.append(", lastOrderOfObjectiveInSection=");
		builder.append(lastOrderOfObjectiveInSection);
		builder.append(", totalOfBehavior=");
		builder.append(totalOfBehavior);
		builder.append(", showTotalExamItemNoInSection=");
		builder.append(showTotalExamItemNoInSection);
		builder.append("]");
		return builder.toString();
	}

	
	
}