package esi.ew.report.policy;

import java.io.IOException;
import java.util.PropertyResourceBundle;

import esi.ew.common.TYPE_FLAG;

public class PolicyController {
	public static int LogSizeLimit = 0;
	public static boolean VerifyData = false;
	public static boolean SystemCommonLog = false;
	public static boolean CommonLog = true;
	public static boolean SQLExceptionLog = false;
	public static boolean SQLCommandLog = false;
	public static boolean ExceptionLog = false;

	static {
		
		PropertyResourceBundle propResBundle = null;
		try {
			propResBundle = new PropertyResourceBundle(Thread.currentThread().getContextClassLoader().getResourceAsStream("resources/config_policy_core.properties"));
			
			try{
				TYPE_FLAG lo_VerifyData = TYPE_FLAG.getEnum(Integer.parseInt(propResBundle.getString("VerifyData")));
				if( lo_VerifyData.getValue() == TYPE_FLAG.TYPE_YES.getValue()){
					VerifyData = true;
				}else{
					VerifyData = false;
				}
			}catch(Exception ex){
				VerifyData = false;
			}
			try{
				TYPE_FLAG lo_SystemCommonLog = TYPE_FLAG.getEnum(Integer.parseInt(propResBundle.getString("SystemCommonLog")));
				if( lo_SystemCommonLog.getValue() == TYPE_FLAG.TYPE_YES.getValue()){
					SystemCommonLog = true;
				}else{
					SystemCommonLog = false;
				}
			}catch(Exception ex){
				SystemCommonLog = false;
			}
			
			try{
				TYPE_FLAG lo_CommonLog = TYPE_FLAG.getEnum(Integer.parseInt(propResBundle.getString("CommonLog")));
				if( lo_CommonLog.getValue() == TYPE_FLAG.TYPE_YES.getValue()){
					CommonLog = true;
				}else{
					CommonLog = false;
				}
			}catch(Exception ex){
				ex.printStackTrace();
				CommonLog = false;
			}
			try {
				TYPE_FLAG lo_SQLCommandLog = TYPE_FLAG.getEnum(Integer.parseInt(propResBundle.getString("SQLCommandLog")));
				if (lo_SQLCommandLog.getValue() == TYPE_FLAG.TYPE_YES.getValue()) {
					SQLCommandLog = true;
				} else {
					SQLCommandLog = false;
				}
			} catch (Exception ex) {
//				ex.printStackTrace();
				SQLCommandLog = false;
			}
			try {
				TYPE_FLAG lo_SQLExceptionLog = TYPE_FLAG.getEnum(Integer.parseInt(propResBundle.getString("SQLExceptionLog")));
				if (lo_SQLExceptionLog.getValue() == TYPE_FLAG.TYPE_YES.getValue()) {
					SQLExceptionLog = true;
				} else {
					SQLExceptionLog = false;
				}
			} catch (Exception ex) {
//				ex.printStackTrace();
				SQLExceptionLog = false;
			}
			
			try {
				TYPE_FLAG lo_ExceptionLog = TYPE_FLAG.getEnum(Integer.parseInt(propResBundle.getString("ExceptionLog")));
				if (lo_ExceptionLog.getValue() == TYPE_FLAG.TYPE_YES.getValue()) {
					ExceptionLog = true;
				} else {
					ExceptionLog = false;
				}
			} catch (Exception ex) {
//				ex.printStackTrace();
				ExceptionLog = false;
			}
			
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void init() {
	}
	
	public static void main(String[] args) {
		
	}
}
